function Subtitle(){
	var init = function(){
		//interface
		_pub.show = show;
		_pub.hide = hide;	
		_pub.ensureShow = ensureShow;
		_pub.loadTracks = loadTracks;
		_pub.clearTracks = clearTracks;
		_pub.nextTrack = nextTrack;
		_pub.getCurTrackTitle = getCurTrackTitle;
		_pub.tagCurTrackAsHeb = tagCurTrackAsHeb;
		hide();
	}

	var _pub = this;

	var HEB = { "std" : 1, "inv" : 2 };
	var m_visible = false;
	var m_vis_timeout = 0;
	var m_cur_track = 0;
	var m_tracks = [];

	var getCurTrackTitle = function(){
		if (!m_tracks.length)
			return "No Subtitles";
		if (!m_cur_track)
			return "Off";
	  	var res = "";	
		try{
			res = m_tracks[m_cur_track][1];
			if (m_tracks[m_cur_track][2] == HEB.inv)
				res += "(Inverse)";
		}
		catch(e){
			res = "Disabled";
		}
		return res;		
	}
	
	var tagCurTrackAsHeb = function(){
		if (m_tracks.length && m_tracks[m_cur_track] && !m_tracks[m_cur_track][2]){
			m_tracks[m_cur_track][2] = HEB.std;
		}
	}
	
	var doShow = function(){
		m_vis_timeout = 0;
		m_visible = true;
		if (m_cur_track < 1)
			return;
		JSTV.Player.Subtitle.Show();
	}

	var show = function(){
		m_vis_timeout = window.setTimeout(doShow,0);
	}

	var ensureShow = function(){
		if (!m_vis_timeout && m_visible)
			show();
	}

	var hide = function(){
		JSTV.Player.Subtitle.Hide();
		m_visible = false;
		if (m_vis_timeout)
			window.clearTimeout(m_vis_timeout);
	}
	
	var clearTracks = function(){
		//JSTV.System.DebugString("clear tracks:");
		hide();
		m_cur_track = 0;
		m_tracks = [];
	}

	var loadTracks = function(){
		//JSTV.System.DebugString("load tracks:" + JSTV.Player.Subtitle.GetTracks());
		var tmp=null
		try{
			tmp = eval(JSTV.Player.Subtitle.GetTracks());
			if (tmp && tmp.Subtitles)
				m_tracks = tmp.Subtitles;
			if (m_tracks.length > 1)
				m_cur_track = 1;	
		}
		catch(e){
			clearTracks();
			tmp=null;
		}
		if (JSTV.Player.Subtitle.IsInverseOn()==true)
			JSTV.Player.Subtitle.InverseOff();
		ensureShow();
		return m_tracks;
	}

	var nextTrack = function(){
		if (m_tracks.length <= 1)
			return;
		JSTV.Player.Subtitle.Hide();
	  	if (m_tracks[m_cur_track][2]==HEB.inv){
	  		m_tracks[m_cur_track][2] = HEB.std;
	  		JSTV.Player.Subtitle.InverseOff();
	  	}
	  	else if (m_tracks[m_cur_track][2]==HEB.std){
	  		m_tracks[m_cur_track][2] = HEB.inv;
	  		JSTV.Player.Subtitle.InverseOn();
	  	}
		if (m_tracks[m_cur_track][2]!=HEB.inv)
			++m_cur_track;
		if (m_cur_track >= m_tracks.length)
			m_cur_track = 0;
	  	if (m_cur_track > 0){
	  		//if (m_cur_track == 1)
	  			ensureShow();
			JSTV.Player.Subtitle.UseTrack(m_cur_track);
		}
		else{
			//JSTV.Player.Subtitle.Hide();
			JSTV.Player.Subtitle.UseTrack(1);
		}
		//JSTV.System.DebugString("m_cur_track:" + m_cur_track);
		//JSTV.System.DebugString("m_tracks.length:" + m_tracks.length);
	}

	init();
}



