self.name="system_info";

String.prototype.trim = function () {
return this.replace(/^\s*|\s*$/,"");
}

//general
function eliminate_spaces(input_val) 
{ 
		 //JSTV.System.DebugString("input:"+input_val+"x");
         var words = input_val.split(" "); 
         var correct_value = ""; 
         var real_word_started = false; 
         for (i=0; i<words.length; i++) 
         { 
                 if ( real_word_started == false ) 
                 { 
                         if ( words[i] != "" ) 
                         { 
                                 correct_value += words[i]; 
                                 real_word_started = true; 
                         } 
                 } 
                 else 
                 { 
                         if ( words[i] != "" ) 
                                 correct_value += " " + words[i]; 
                 } 
         } 
         return correct_value; 
}

//remove new line, carriage return and tab chars
function remove_nl(s)
{ 
  return s.replace(/[\n\r\t]/g,""); 
} 

//globals

var sinfo_arr = new Array();
var sinfo_vals_arr = new Array();

function sinfo_update_info(){
	var inx=0;
	var last_error = JSTV.Player.GetLastError();
	if (last_error.url){
		last_error.url = last_error.url.trim();
		if (last_error.url.length > 25){
			last_error.url = last_error.url.substr(0,5) + "..." + last_error.url.substr(last_error.url.length-18);
		}
	}
	if (last_error.msg){
		if (last_error.msg.length > 25){
			last_error.msg0 = last_error.msg.substr(0, 25).trim();
			last_error.msg1 = last_error.msg.substr(25,25).trim();
			if (last_error.msg.length > 50){
			  last_error.msg2 = last_error.msg.substr(50).trim();
			}
		}
		else
			last_error.msg0 = last_error.msg;
	}

	//IP Address
	sinfo_arr[inx] = "IP Address";
	sinfo_vals_arr[inx++] = JSTV.Network.GetEffectiveIPAddress();

	//Connectivity
	var CONN_INX = inx;
	sinfo_arr[inx] = "Connectivity"
	sinfo_vals_arr[inx++] = ASTB.GetEnv("CONN_OPTION");

	//Wifi Network Name
	sinfo_arr[inx] = "Wifi Net. Name"
	sinfo_vals_arr[inx++] = ASTB.GetEnv("WIRELESS_NAME");

	//Use WEP
	sinfo_arr[inx] = "Use WEP";
	sinfo_vals_arr[inx++] = ASTB.GetEnv("USE_WEP");

	//Wifi Auth. Mode
	sinfo_arr[inx] = "Wifi Auth. Mode";
	sinfo_vals_arr[inx++] = ASTB.GetEnv("WIFI_AUTH");

	//Lan Mac Address
	sinfo_arr[inx] = "Lan Mac Address";
	sinfo_vals_arr[inx++] = JSTV.Network.GetLanMacAddress();

	//Wifi Mac Address
	sinfo_arr[inx] = "Wifi Mac Address";
	sinfo_vals_arr[inx++] = JSTV.Network.GetWifiMacAddress();

	//Use DHCP
	sinfo_arr[inx] = "Use DHCP";
	if (sinfo_vals_arr[CONN_INX] == "LAN")
	{
		sinfo_vals_arr[inx++] = ASTB.GetEnv("LAN_DHCP_USE");
	}
	else if (sinfo_vals_arr[CONN_INX] == "Wireless")
	{
		sinfo_vals_arr[inx++] = ASTB.GetEnv("WIFI_DHCP_USE");
	}
	else
		sinfo_vals_arr[inx++] = "";

	//Hostname
	sinfo_arr[inx] = "Hostname";
	sinfo_vals_arr[inx++] = ASTB.GetEnv("HOST_NAME");

	//Workgroup
	sinfo_arr[inx] = "Workgroup";
	sinfo_vals_arr[inx++] = ASTB.GetEnv("WORKGROUP");

	//Software Version
	sinfo_arr[inx] = "Software Version";
	sinfo_vals_arr[inx++] = JSTV.System.GetSoftwareVersion();

	//Hardware Version
	sinfo_arr[inx] = "Hardware Version";
	sinfo_vals_arr[inx++] = JSTV.System.GetHardwareVersion();

	//Last Error Message
	sinfo_arr[inx] = "Last Error";
	sinfo_vals_arr[inx++] = last_error.msg0 ? last_error.msg0.toLowerCase() : "None";
	if (last_error.msg1){
		sinfo_arr[inx] = "";
		sinfo_vals_arr[inx++] = last_error.msg1 ? last_error.msg1.toLowerCase() : "";
	}
	
	if (last_error.msg2){
		sinfo_arr[inx] = "";
		sinfo_vals_arr[inx++] = last_error.msg2 ? last_error.msg2.toLowerCase() : "";
	}
	
	//Last Error URL
	if (last_error.msg){
		sinfo_arr[inx] = "Last Error URL";
		sinfo_vals_arr[inx++] = last_error.url ? last_error.url.toLowerCase() : "None";
	}

	//HD Size
	sinfo_arr[inx] = "HD Size";
	sinfo_vals_arr[inx++] = remove_nl(eliminate_spaces(JSTV.System.GetHDSize()));

	//HD Free Space
	sinfo_arr[inx] = "HD Free Space";
	sinfo_vals_arr[inx++] = remove_nl(eliminate_spaces(JSTV.System.GetHDFreeSpace()));
	
}
sinfo_update_info();


//system info controller object
var sinfo_cntr = new Object();
sinfo_cntr.curr_screen = 0;
sinfo_cntr.scr_size = 5;	
sinfo_cntr.options_no = sinfo_arr.length;

//windows handles, windows-related vars
var sinfo_win = undefined; 
var sinfo_arrows_imgs_win = undefined;
var sinfo_text_win = undefined; 
var sinfo_wins_left = 3; 
var sinfo_all_wins_done = false;

//image handles
//var sinfo_img_bg;   
var sinfo_up;
var sinfo_down; 
var sinfo_empty;

var sinfo_mode = false;	//whether system info is hidden or shown. when the page first loads, it is hidden. 
var sinfo_focus_mode = false;	//whether system info is in focus. when the page first loads, it's not. (focus should be done in the "done" function)
var sinfo_common_kh = undefined; 
var sinfo_done_func = new Function();
var sinfo_prev_kh;
var sinfo_prefix = "";
sinfo_initial_x = 0; 
sinfo_initial_y = 0;
           
function sinfo_load_imgs()
{    
	// System Info image
	//sinfo_img_bg = new Image();
	//sinfo_img_bg.src = "images_system/Sys_Info_bg_large.png";  
	sinfo_up = new Image();
	sinfo_up.src = "images_system/Sys_Info_up.png";
	sinfo_down = new Image();
	sinfo_down.src = "images_system/Sys_Info_down.png";
	sinfo_empty = new Image();
	sinfo_empty.src = "images_system/empty1.png";	         	
}

function sinfo_empty_keyhandler()
{
	return false;
}

function sinfo_write_text(win_name, out_doc)
{   
	//JSTV.System.DebugString("in write text. win_name: " + win_name); 
	//JSTV.System.DebugString("in write text. out_doc: " + out_doc); 
	switch (win_name)
	{ 
	case "sinfo_text_win":	// writing System Info window text
		out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");
		
		out_doc.write("<form name='sys_text_form'>");
		var aux;
		for (i = 0; i < sinfo_cntr.scr_size; i++)
		{
			//x = sinfo_arr[i]; 
			//y = sinfo_vals_arr[i];  
			aux = "option" + i; 
			aux2 = "option_val" + i;
			//JSTV.System.DebugString("aux: " + aux);
			//JSTV.System.DebugString("aux2: " + aux2);				
			out_doc.write("<tr>");
			out_doc.write("<td height='38' width='22'></td>");		
			out_doc.write("<td height='38' width='192'>");		
			//out_doc.write('<input name=' + aux + ' type="button" height="39" width="202" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:10pt;font-weight:bold" value="#L' + sinfo_arr[i] + '"  >');

			if (skin=="Dark")	
				out_doc.write('<input name=' + aux + ' type="button" height="38" width="192" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:8pt;font-weight:bold;color:#ffffff" value=""  >');
			else 
				out_doc.write('<input name=' + aux + ' type="button" height="38" width="192" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:8pt;font-weight:bold" value=""  >');
			out_doc.write("</td>");
			out_doc.write("<td height='38' width='273'>");
			//out_doc.write('<input name=' + aux2 + ' type="button" height="39" width="283" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:10pt;font-weight:bold" value="#L' + sinfo_vals_arr[i] + '"  >');		

			if (skin=="Dark")	
				out_doc.write('<input name=' + aux2 + ' type="button" height="38" width="273" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:8pt;font-weight:bold;color:#ffffff" value=""  >');		
			else
				out_doc.write('<input name=' + aux2 + ' type="button" height="38" width="273" selimage="images_system/empty1.png" borderimage="images_system/empty1.png" style="font-size:8pt;font-weight:bold" value=""  >');		

			out_doc.write("</td>");
			out_doc.write("</tr>");
		}
		out_doc.write("</form></table>"); 
	
		break;
	default:
		break;
	}	
}

//write the actual values in the text table
function write_vals(win_name, out_doc)
{   
	JSTV.System.DebugString("start");
	var i;       
	var aux;
	if (win_name == "sinfo_text_win")
	{       
		for (i = 0; i < sinfo_cntr.scr_size; ++i)
		{
			aux = "option" + i;
			out_doc.sys_text_form[aux].value = "#L" + (sinfo_arr[i] ||  ""); 
			aux = "option_val" + i;
			out_doc.sys_text_form[aux].value = "#L" + (sinfo_vals_arr[i] || ""); 
		}
       }
       else
       {	
       		JSTV.System.DebugString("write_val. Warning: function called from wrong window");
       }
       JSTV.System.DebugString("end");
}

// Open the System Info text window
function sinfo_open_sys_text()
{
	//JSTV.System.DebugString("in sinfo_open_sys_text");  
	var x = sinfo_initial_x + 10;
	var y = sinfo_initial_y + 60;
	sinfo_text_win = window.open(sinfo_prefix + "sinfo_text_win.html", "sinfo_text_win", "takefocus=no,screenx="+x+",screeny="+y+",width=487,height=200");	
} 

// this function is executed fron sys_info.html
// it sets the src property of the image in sys_info.html to the required background image
function sinfo_put_sys_img(win_name, out_doc)
{ 
	var sys_img = out_doc.images; 
	//JSTV.System.DebugString(sys_img[0].name);
	sys_img[0].src = sinfo_img_bg.src;  
	//JSTV.System.DebugString(sys_img[0].src);
}

function sinfo_open_arrows_imgs()
{  
	var x = sinfo_initial_x + 8;
	var y = sinfo_initial_y + 55;
	sinfo_arrows_imgs_win  = window.open(sinfo_prefix + "sinfo_arrows_imgs.html", "sinfo_arrows_imgs_win", "takefocus=no,screenx="+x+",screeny="+y+",width=100,height=214");
}

// this function is executed from sinfo_arrows_imgs.html
// it writes the html of the table which contains the arrows
function sinfo_put_arrows_imgs(win_name, out_doc)
{    
	//JSTV.System.DebugString("win_name: " + win_name) 
	
        out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");  
        out_doc.write("<tr>");
	out_doc.write("<td width='14' height='8'><img name='sys_up' width=14 height=8 src=''/></td></tr>"); 
	out_doc.write("<tr><td height='190'></td></tr>");		
	//out_doc.write("<tr><td width=0></td>");
	out_doc.write("<tr>");
	out_doc.write("<td width='14' height='8'><img name='sys_down' width=14 height=8 src=''/></td></tr>"); 
	out_doc.write("</table>"); 		 	
}

// this function is executed from sinfo_arrows_imgs.html, in postload. (but b4 opening the text window).
// it sets the src property of the images in sinfo_arrows_imgs.html to either
// empty or not.
function sinfo_put_imgs(win_name, out_doc)
{  
    var imgs = out_doc.images;
    //JSTV.System.DebugString("imgs length: " + imgs.length); 
   	   
   imgs[0].src = sinfo_empty.src;	//at startup, the first screen, there's no scroll up option, only down
   imgs[1].src = sinfo_down.src;
   
   //JSTV.System.DebugString(i+ ": " + imgs[i].src); 
   
   //the images need to be prefixed in order to be used in the scroll function. they don't need to be prefixed when loading,
   //so this is one only now:
   sinfo_empty.src = sinfo_prefix + sinfo_empty.src; 
   sinfo_up.src = sinfo_prefix + sinfo_up.src;
   sinfo_down.src = sinfo_prefix + sinfo_down.src;
}


function sinfo_write_html(win_name, out_doc)
{  

	switch(win_name)
	{		
		case "sinfo_win": 	// write the html of the System Info window
			out_doc.write("<form name='sys_form' id='001'>");
			out_doc.write("<table border='0' cellpadding='0' cellspacing='0'>");
			out_doc.write("<tr>");
			out_doc.write("<td width='497' height='269'><img name='sys_bg' width=497 height=269 src='images_system/Sys_Info_bg_large.png'/></td></tr>");
			out_doc.write("</table></form>");
			break;
		default:
			break;
	}
}


// System Info - scroll through the screens
// Assumes there are only 4 screens
function sinfo_sys_scroll()
{            
	var i;       
	var aux;
	if (sinfo_text_win)
	{
		//JSTV.System.DebugString("in sys_scroll. sinfo_text_win exists");  
		//JSTV.System.DebugString("url: " + sinfo_text_win.document.URL);
		//aux = "option"+1;
	        //JSTV.System.DebugString("val: " + sinfo_text_win.document.sys_text_form[aux].value);
	        
	        for (i = 0; i < sinfo_cntr.scr_size; ++i)
		{
			aux = "option" + i;
			sinfo_text_win.document.sys_text_form[aux].value = "#L" + (sinfo_arr[i + sinfo_cntr.curr_screen * sinfo_cntr.scr_size] || ""); 
			aux = "option_val" + i;
			sinfo_text_win.document.sys_text_form[aux].value = "#L" + (sinfo_vals_arr[i + sinfo_cntr.curr_screen * sinfo_cntr.scr_size] || ""); 
		}
		if (sinfo_arrows_imgs_win)
		{
			var imgs = sinfo_arrows_imgs_win.document.images;
			
			if (sinfo_cntr.curr_screen==0){
			   imgs[0].src = sinfo_empty.src;
			   imgs[1].src = sinfo_down.src; 
			}
			else if (sinfo_arr[(sinfo_cntr.curr_screen+1) * sinfo_cntr.scr_size]){
			   imgs[0].src = sinfo_up.src;
			   imgs[1].src = sinfo_down.src;
			}
			else{
			   imgs[0].src = sinfo_up.src;
			   imgs[1].src = sinfo_empty.src; 
			}
		}

	}
	else
	{
		JSTV.System.DebugString("sinfo_sys_scroll. Error-system text window not found");
	}
} 


// System Info - keyhandler
// handles the up, down keys. 
function sinfo_keyhandler(e)
{ 
	JSTV.System.DebugString("in sinfo_keyhandler");
	Key = e.which;
    	switch (Key)
    	{
	case JSTV.Device.kbd.DOWN:
		//JSTV.System.DebugString("sinfo_cntr.curr_screen b4 increment: " + sinfo_cntr.curr_screen);
		if (sinfo_cntr.curr_screen < (sinfo_arr.length / sinfo_cntr.scr_size) - 1)
		{
			++sinfo_cntr.curr_screen; 
			//JSTV.System.DebugString("sinfo_cntr.curr_screen after increment: " + sinfo_cntr.curr_screen);
			sinfo_sys_scroll();
		}
		break; 
	case JSTV.Device.kbd.UP: 
		//JSTV.System.DebugString("sinfo_cntr.curr_screen: " + sinfo_cntr.curr_screen);
		if (sinfo_cntr.curr_screen > 0)
		{
			--sinfo_cntr.curr_screen;
			//JSTV.System.DebugString("sinfo_cntr.curr_screen: " + sinfo_cntr.curr_screen);
			sinfo_sys_scroll();
		}                    
		break; 
	default:
		break;
	}
	
	if (sinfo_common_kh)
	{
		return sinfo_common_kh(e);
	}
	else
	{
		JSTV.System.DebugString("sinfo_keyhandler. Warning: no common keyhandler is set.");
	}
	
}

function sinfo_window_done(name)
{  
	JSTV.System.DebugString("WINDOW_DONE:" + name);
	sinfo_wins_left--;
	JSTV.System.DebugString("wins left:" + sinfo_wins_left);
	if (sinfo_wins_left == 0)
	{ 
		JSTV.System.DebugString("All Windows Done");
		sinfo_all_wins_done = true;
		sinfo_done_func();
	}
}


// sets the document onkeypress function back to the common keyhandler
function sinfo_doBlur()
{  
   if (sinfo_focus_mode) 
   {            
   	//document.onkeypress=sinfo_common_kh; 
	document.onkeypress=sinfo_prev_kh;
   	sinfo_focus_mode = false;
	JSTV.System.DebugString("---end Doblur---");
   }
}

function sinfo_doFocus(kh)
{  
   //if (!sinfo_focus_mode)
   //{
    	sinfo_prev_kh = document.onkeypress;
   	document.onkeypress=sinfo_keyhandler;
   	sinfo_common_kh = kh; 
   	sinfo_focus_mode = true;

	sinfo_update_info();
	sinfo_sys_scroll()

	JSTV.System.DebugString("---end DoFocus---");
   //}
}

function sinfo_doLoad(prefix, func, x, y)
{    
	sinfo_prefix = prefix;
	sinfo_load_imgs();                        
	sinfo_done_func = func;  
	sinfo_initial_x = x;                 
	sinfo_initial_y = y;
        sinfo_win = window.open(sinfo_prefix + "sys_info.html", "sinfo_win", "takefocus=no,screenx="+x+",screeny="+y+",width=502,height=274");
	JSTV.System.DebugString("---end DoLoad---");

}                                                                      
 
// shows the system info windows.
// this function doesn't handle any keyhandler issues, but assumes they're dealt with elsewhere!
function sinfo_doToFront()
{
	sinfo_mode = true;
	if (sinfo_win)
	{             
		//JSTV.System.DebugString("in sinfo_doShow. sinfo_win exists");
		sinfo_win.toFront();
		if (sinfo_arrows_imgs_win)
		{ 
			//JSTV.System.DebugString("sinfo_doShow. sinfo_arrows_imgs_win exists");	
			sinfo_arrows_imgs_win.toFront();
		} 
		else
		{
			JSTV.System.DebugString("sinfo_doShow. Warning: sinfo_arrows_imgs_win not found, nothing to show");
		} 
		if (sinfo_text_win) 
		{                 
			//JSTV.System.DebugString("sinfo_doShow. sinfo_text_win exists");
			sinfo_text_win.toFront();  
		} 
		else
		{
			JSTV.System.DebugString("sinfo_doShow. Warning: sinfo_text_win not found, nothing to show");
		}     
	
	}
	else
	{
		JSTV.System.DebugString("sinfo_doShow. Warning: sinfo_win not found, nothing to show");
	}
	JSTV.System.DebugString("---end DoShow---");   
}

// hides the system info windows.
// this function doesn't handle any keyhandler issues, but assumes they're dealt with elsewhere!
function sinfo_doToBack()
{
	sinfo_mode = false;
	if (sinfo_win)
	{ 
		sinfo_win.toBack();
		if (sinfo_text_win)
		{
			sinfo_text_win.toBack();  
		} 
		else
		{
			JSTV.System.DebugString("sinfo_doHide. Warning: sinfo_text_win not found, nothing to hide");
		}  
		if (sinfo_arrows_imgs_win)
		{  
			sinfo_arrows_imgs_win.toBack();
		}
		else
		{
			JSTV.System.DebugString("sinfo_doHide. Warning: sinfo_arrows_imgs_win not found, nothing to hide");
		} 
		
	}
	else
	{
		JSTV.System.DebugString("sinfo_doHide. Warning: sinfo_win not found, nothing to hide");
	}
	JSTV.System.DebugString("---end DoHide---");
}
